from GBA import GBA


def dfs(gba : GBA, s1, s2, sets, eactuel, index, past):
    if index == len(sets):
        return eactuel == s2
    past.add((eactuel, index))
    for ns in gba.transitions[eactuel]:
        if ns in sets[index] and (ns, index + 1) not in past:
            return dfs(gba, s1, s2, ns, index + 1, past)
        if (ns, index) not in past:
            return dfs(gba, s1, s2, ns, index, past)
    return False


def path(gba: GBA, s1, s2, sets):
    past = set()
    return dfs(gba, s1,s2,  s1, 0, past)

#Entrée : une formule sous forme de liste de littéraux (ie une variable ou sa négation)
#Vérifie que cette formule est consistente cad qu'elle ne contient pas à la fois une variable et sa négation
def is_consistent(formula):
	for l in formula:
		if "~"+l in formula:
			return False
	return True

#Entrées : 1 automate de buchi
#Sortie : renvoie True si cet automate n'admet aucune exécution et false sinon
def is_Buchi_empty(buchi):
	#à compléter
	return False

#Entrées : 1 automate de buchi généralisé
#Sortie : renvoie True si cet automate n'admet aucune exécution et false sinon
def is_GBA_empty(gba):
	#à compléter
	for init in gba.initial_state:
		for accept in gba.accepting_sets:
			for acc in accept:
				if path(gba, init, acc, gba.accepting_sets):
					return False
	return True


